#ifndef BOUNDINGBOX
#define BOUNDINGBOX

#include "BoundingVolume.h"

// An axis aligned bounding box
class BoundingBox : public BoundingVolume
{
	Vector3f minExtent;
	Vector3f maxExtent;

public:
	BoundingBox(const Vector3f *pos, const Vector3f& min, const Vector3f& max);

	// Test if the point is inside this volume
	virtual bool inside(const Vector3f& point) const;

	// Test if the volume is on the positive side of the plane
	virtual bool positiveSide(const Plane& plane) const;

	// Draw this volume as wireframe
	virtual void draw() const;
};

#endif
