#ifndef BOUNDINGSPHERE
#define BOUNDINGSPHERE

#include "BoundingVolume.h"

// A simple bounding sphere
class BoundingSphere : public BoundingVolume
{

public:
	float radius;

	BoundingSphere(float radius) : BoundingVolume()
	{ this->radius = radius; }

	BoundingSphere(const Vector3f *pos, float radius) : BoundingVolume(pos)
	{ this->radius = radius; }

	// Test if the point is inside this volume
	virtual bool inside(const Vector3f& point) const;

	// Test if the volume is on the positive side of the plane
	virtual bool positiveSide(const Plane& plane) const;

	// Find if this volume intersects the line segment
	// defined by a projectile's oldPosition and newPosition
	virtual bool intersects(const Vector3f& oldPosition, const Vector3f& newPosition) const;

	virtual bool intersects(const BoundingVolume* volume) const;

	float distance(const Vector3f& pos) const;

	// Draw this volume as wireframe for now
	virtual void draw() const;
};

#endif