#ifndef FRAMECOUNT_H
#define FRAMECOUNT_H

#ifndef _WINDOWS_
	#include <sys/time.h>
	#define ELAPSED frameEndTime.tv_sec - frameStartTime.tv_sec + \
             ((frameEndTime.tv_usec - frameStartTime.tv_usec)/1.0E6);
#else
	void gettimeofday(timeval *t, void *not_used)
	{ t->tv_usec = (long) GetTickCount(); }

	#define ELAPSED (float)(frameEndTime.tv_usec+1 - frameStartTime.tv_usec) / 1.0E3f
#endif

// Time measuring variables
struct timeval frameStartTime;
struct timeval frameEndTime;

void frameStart()
{  gettimeofday(&frameStartTime, NULL); }

float frameEnd()
{
   gettimeofday(&frameEndTime, NULL);
   return ELAPSED;
}

#endif