#ifndef FRUSTRUM_H
#define FRUSTRUM_H

#include "Plane.h"
class BoundingVolume;

class Frustrum
{
	enum { leftPlane = 0, rightPlane = 1, bottomPlane = 2, 
			topPlane = 3, nearPlane = 4, farPlane = 5 };
	enum { NoPlanes = 6 };

	Plane planes[NoPlanes];
	bool enabled;

public:
	mutable int volumesCulled;

	Frustrum() { enabled = true; volumesCulled = 0; }

	// Recalculates the bounding planes
	void recalcPlanes();

	// Tests if the given volume is within the frustrum
	bool inside(const BoundingVolume* bVolume) const;

	// Enables or Disables view frustrum culling
	void toggle() { enabled = !enabled; }
};

#endif