#ifndef MATRIX_H
#define MATRIX_H

#include "Vector3.h"

struct Matrix
{
	// Note: stored in column major order
	float m11, m21, m31, m41;
	float m12, m22, m32, m42;
	float m13, m23, m33, m43;
	float m14, m24, m34, m44;

	Matrix() { }

	Matrix(const float i11, const float i21, const float i31, const float i41,
		   const float i12, const float i22, const float i32, const float i42,
		   const float i13, const float i23, const float i33, const float i43,
		   const float i14, const float i24, const float i34, const float i44)
	{
		m11 = i11; m21 = i21; m31 = i31; m41 = i41;
		m12 = i12; m22 = i22; m32 = i32; m42 = i42;
		m13 = i13; m23 = i23; m33 = i33; m43 = i43;
		m14 = i14; m24 = i24; m34 = i34; m44 = i44;
	}

	Matrix(const Vector3f& s, const Vector3f& u, const Vector3f& f)
	{
		m11 = s.x; m21 = u.x; m31 = f.x; m41 = 0.0f;
		m12 = s.y; m22 = u.y; m32 = f.y; m42 = 0.0f;
		m13 = s.z; m23 = u.z; m33 = f.z; m43 = 0.0f;
		m14 = 0.0f; m24 = 0.0f; m34 = 0.0f; m44 = 1.0f;
	}
};

#endif