#ifndef MESH_H
#define MESH_H

#include <iostream>
#include <vector>
#include "Geometry.h"

class Mesh : public Geometry
{
	//data structure to store triangle data
	struct Triangle
	{
		//indices into the vertex array   
		Vector3i indices;
		Vector3f normal;
		Vector3f color;
	};

	//all the triangles in the mesh
	std::vector<Triangle> triangles;

	//all the vertices in the mesh
	std::vector<Vector3f> vertices;

	//for computing the extent of the model
	float max_x, max_y, max_z, min_x, min_y, min_z;
	float max_extent;

	// The center point of the mesh
	Vector3f center;

	void readStream(std::istream& is);
	void readLine(char* str);
	void drawTriangle(Triangle t) const;
	BoundingVolume* getBoundingVolume() const;

protected:
	void setupVertices();

public:
	Mesh(const char* filename);
};

#endif