#ifndef MODEL3DS_H
#define MODEL3DS_H

#pragma once
#include "Geometry.h"
#include "Vector3.h"
#include "texture_loading.h"
#include "3ds.h"

class Model3ds : public Geometry
{
public:
   Model3ds(void);
   Model3ds(char* filename, float y_deg, float scle, unsigned int tex);
   ~Model3ds(void);
   
   void load3dsFile(char* filename);
   BoundingVolume* getBoundingVolume() const;
   
   virtual void draw() const;
protected:
	void setupVertices();

private:
   unsigned int textures[MAX_TEXTURES];		// This holds the texture info, referenced by an ID
   CLoad3DS load;       										// This is 3DS class.
   t3DModel model;                                    // This holds the 3D Model info that we load in
   float max_x, max_y, max_z, min_x, min_y, min_z;
   float max_extent;                          //the maximum extent of the model; one of the following:
                                              //max_x - min_x || max_y - min_y || max_z - min_z
   float radius;
   Vector3f center;
   float y_rotation;
   float scale;
   int uniform_texture;
   unsigned int totalVertices;
};

#endif
