#include <cstdlib>
#include <GL/glut.h>
#include "Object.h"
#include "Geometry.h"

Object::Object(Geometry *g, const Vector3f& startPos)
{
	if (g) geometry = g->alloc(); else geometry = 0;
	position = startPos;
	rotation.set(0.0f, 0.0f, 0.0f, 1.0f);
	visible = true;
}

Object::~Object()
{
	if (geometry)
	{
		geometry->dealloc();
		geometry = 0;
	}
}

void Object::draw() const
{
	if (!visible) return;

	Vector3f axis;
	float angle;
	rotation.getAxisAngle(axis, angle);

	glPushMatrix();
	glTranslatef(position.x, position.y, position.z);
	glRotatef(angle*180.0f/PI, axis.x, axis.y, axis.z);
	geometry->draw();
	glPopMatrix();
}
