#ifndef OBJECT_H
#define OBJECT_H

#include "math_util.h"
#include "Quaternion.h"
class Geometry;

// The generic Geometry carrying object in our game
class Object
{
protected:
	// The geometry of the object
	Geometry *geometry;

	// The position of the object in world coordinates
	Vector3f position;

	// The rotation that describes this object
	Quaternion rotation;

	// Is this object visible
	bool visible;

public:
   //Object() {};
	Object(Geometry *g, const Vector3f& startPos);
	virtual ~Object();

	virtual void update(float time) { }
	virtual void draw() const;

	void setRotation(const Quaternion& quat) 
	{ rotation.set(quat); }

	void setRotation(float pitch, float yaw, float roll) 
	{ rotation.set(pitch, yaw, roll); }

   Geometry *getGeometry() { return geometry; }

	const Vector3f& getPosition() const { return position; }
	const Quaternion& getRotation() const { return rotation; }
	void toggleVisible() { visible = !visible; }
};

#endif