#ifndef OBJECT3D_H
#define OBJECT3D_H

#include <list>
#include "Object.h"
class BoundingVolume;
class Projectile;
class Frustrum;

class Object3d : public Object
{
protected:
	// Bounding box is relative to position
	BoundingVolume *bVolume;
	Vector3f color;
	bool culled;

	Object3d();
	Object3d(const Object3d&);
	Object3d& operator=(const Object3d&);

public:
	Object3d(Geometry *g, const Vector3f& startPos);
	virtual ~Object3d();

	void setBoundVolume(BoundingVolume *vol);
	const BoundingVolume* getBoundVolume() { return bVolume; }
	//bool inside(Vector3f point);
	void toggleBVolumeVisible();
	void testFrustrum(const Frustrum& frustrum);

	void setColor(const Vector3f& col)
	{ color.set(col); }

	virtual void draw() const;
	virtual void drawBoundingVolume();
	virtual void hit(const Projectile* projectile, const Vector3f& location) { }

	static std::list<Object3d*> objects;
};

typedef std::list<Object3d*> ObjectCollection;
typedef std::list<Object3d*>::iterator ObjectIter;

#endif