#include "Vector3.h"
#include "Plane.h"

void Plane::set(const float a, const float b, const float c, const float d)
{
	normal.set(a, b, c);
	distance = d / normal.length();
	normal.normalize();	
}

Vector3f Plane::getRandomPoint()
{
	float x, y, z;

	if (fabs(normal.z) > 0.0005)
	{
		x = (rand() / (float) RAND_MAX);
		y = (rand() / (float) RAND_MAX);
		z = (-normal.x * x - normal.y * y) / normal.z;
	}
	else if (fabs(normal.y) > 0.0005)
	{
		x = (rand() / (float) RAND_MAX);
		z = (rand() / (float) RAND_MAX);
		y = (-normal.x * x - normal.z * z) / normal.y;
	}
	else 
	{
		y = (rand() / (float) RAND_MAX);
		z = (rand() / (float) RAND_MAX);
		x = (-normal.y * y - normal.z * z) / normal.x;
	}

	return Vector3f(x, y, z);
}

Vector3f Plane::getRandomVector()
{ return getRandomPoint() - getRandomPoint();
}