#pragma once

#include <list>
#include "Object2d.h"
class Object3d;

class Projectile : public Object2d
{
protected:
	const Object3d *owner;
	Vector3f velocity;
	int life;
	float power;

public:
	Projectile(int texture, const Vector3f& startPos, const float size, const Object3d* player);
	virtual void update(float time);
	bool alive() const { return life > 0; }
	float getPower() const { return power; }
	void setPower(float pow) { power = pow; }
	void setVelocity(const Vector3f& vel) { velocity = vel; }

    // Factory method for subclasses
	static Projectile* createProj(const Vector3f& startPos, const Vector3f& dir, const Object3d* player) { return 0; }

	static std::list<Projectile*> projectiles;

	static void addProj(Projectile* proj);
    static void updateAll(float time);
	static void drawAll();
};