#pragma once

#include <Cg/cg.h>
#include <Cg/cgGL.h>
#include <vector>
#include "Vector3.h"

class Shader
{
	static CGcontext cgContext;
	static CGprofile cgVertexProfile;

	CGprogram cgProgram;

	// The Parameters Needed For Our Shader
	CGparameter modelViewMatrix;
	CGparameter modelViewIT;
	std::vector<CGparameter> params;

public:
	bool enabled;
	Shader(const char* filename);
	void RecurseParameters(CGparameter parameter);
	void setFloatParam(int paramIndex, float value);
	void setVector3fParam(int paramIndex, const Vector3f& value);
	void setVector4fParam(int paramIndex, const Vector3f& vec, float w);
	void setVector4fParam(int paramIndex, float x, float y, float z, float w);
	void setNamedArray4fParam(const char* paramName, int numElements, float *array);
	void enable() const;
	void disable() const;

	static bool Init();
	static void Deinitialize();
};