#pragma once

#include "Vector3.h"
class Projectile;
class Player;

class Weapon
{
	const Player* player;
	Vector3f leftLocation;
	Vector3f rightLocation;

	float bulletPower;
	float bulletSpeed;
	float bulletSize;
	unsigned int bulletTexture;

	int type;
public:
	enum { PLASMA, ENERGY, BLUE, LIGHTNING, COOL };
	float energyDrain;

	Weapon(const Player* pl, const Vector3f& lLoc, const Vector3f& rLoc, int type);
	void setType(int type);
	void rotate(float angle, const Vector3f& axis)
	{ leftLocation.rotate(angle, axis); rightLocation.rotate(angle, axis); }
	void fire() const;
	void fireOther() const;
};