
#include <assert.h>
#include <stdio.h>
#include "gl_font.h"


GLFont::GLFont(char* which_font, long font_size) {

   BOOL result = 0;
   HFONT font;
   HFONT old;

   font_list = glGenLists(256);
   do {
      font = CreateFont(-font_size, 0, 0, 0, FW_NORMAL, false, false, false,
      ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, ANTIALIASED_QUALITY,
      FF_DONTCARE | DEFAULT_PITCH, which_font);

      HDC dc = GetDC(NULL);
      old = (HFONT)SelectObject(dc, font);
	   result = wglUseFontBitmaps(dc, 0, 255, font_list);
      DWORD error = GetLastError();
	   SelectObject(dc, old);
	   DeleteObject(font);
      ReleaseDC(NULL, dc);

   //assert(result);
   } while (!result);
}


void GLFont::Printf(float x, float y, const char* fmt, ...) {

	char text[256];
	va_list ap;

	if (fmt == NULL)
      return;

	va_start(ap, fmt);
	vsprintf(text, fmt, ap);
	va_end(ap);

   glPushAttrib(GL_LIST_BIT | GL_CURRENT_BIT);
   //glColor3f(0.0f, 0.0f, 0.0f);
   //glDisable(GL_TEXTURE_2D);
   //glDisable(GL_DEPTH_TEST);
   //glDisable(GL_LIGHTING);
   //glDisable(GL_FOG);	
	glListBase(font_list);
	glRasterPos2f(x, y);
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);
   //glEnable(GL_FOG);
   //glEnable(GL_LIGHTING);
   //glEnable(GL_DEPTH_TEST);
   //glEnable(GL_TEXTURE_2D);

   glPopAttrib();
}

void GLFont::Printi(int x, int y, const char* fmt, ...) {

	char text[256];
	va_list ap;

	if (fmt == NULL)
      return;

	va_start(ap, fmt);
	vsprintf(text, fmt, ap);
	va_end(ap);

   glPushAttrib(GL_LIST_BIT | GL_CURRENT_BIT);
   //glColor3f(0.0f, 0.0f, 0.0f);
   //glDisable(GL_TEXTURE_2D);
   //glDisable(GL_DEPTH_TEST);
   //glDisable(GL_LIGHTING);
   //glDisable(GL_FOG);	
	glListBase(font_list);
	glRasterPos2i(x, y);
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);
   //glEnable(GL_FOG);
   //glEnable(GL_LIGHTING);
   //glEnable(GL_DEPTH_TEST);
   //glEnable(GL_TEXTURE_2D);

   glPopAttrib();
}

GLFont::~GLFont() {

   glDeleteLists(font_list, 256);
}