#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <time.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
#include "menus.h"
#include "shipmenuitem.h"
#include "primarymenuitem.h"
#include "secondarymenuitem.h"
#include "okmenuitem.h"
#include "teammenuitem.h"
#include "weapon.h"


#define MENU_POS1 255
#define MENU_POS2 455
#define MENU_POS3 655
#define MENU_POS4 855
#define MENU_POS_OK 565
#define MENU_ITEM_WIDTH 150


extern int windowWidth;
extern int windowHeight;

GLFont* Menus::font;
int Menus::team = 0;
int Menus::ship_type = 0;
int Menus::primary_weapon_type = Weapon::PLASMA;
int Menus::secondary_weapon_type = Weapon::PLASMA;
std::vector<MenuItem*> Menus::team_items;
std::vector<MenuItem*> Menus::ship_type_items;
std::vector<MenuItem*> Menus::primary_weapon_type_items;
std::vector<MenuItem*> Menus::secondary_weapon_type_items;
MenuItem* Menus::ok_item = 0;



void Menus::Init() {

   font = new GLFont("Arial", 18);

   // Make team options.
   MenuItem* def = new TeamMenuItem(0, windowHeight - 150, windowHeight - 200,
      MENU_POS1, MENU_POS1 + MENU_ITEM_WIDTH, "Red Team");
   def->selected = true;
   team_items.push_back(def);
   team_items.push_back(new TeamMenuItem(1, windowHeight - 200, windowHeight - 250,
      MENU_POS1, MENU_POS1 + MENU_ITEM_WIDTH, "Blue Team"));
   team_items.push_back(new TeamMenuItem(2, windowHeight - 250, windowHeight - 300,
      MENU_POS1, MENU_POS1 + MENU_ITEM_WIDTH, "Green Team"));
   team_items.push_back(new TeamMenuItem(3, windowHeight - 300, windowHeight - 350,
      MENU_POS1, MENU_POS1 + MENU_ITEM_WIDTH, "White Team"));

   // Make ship type options.
   def = new ShipMenuItem(0, windowHeight - 150, windowHeight - 200,
      MENU_POS2, MENU_POS2 + MENU_ITEM_WIDTH, "Attack Ship");
   def->selected = true;
   ship_type_items.push_back(def);
   ship_type_items.push_back(new ShipMenuItem(1, windowHeight - 200, windowHeight - 250,
      MENU_POS2, MENU_POS2 + MENU_ITEM_WIDTH, "Fighter"));
   ship_type_items.push_back(new ShipMenuItem(2, windowHeight - 250, windowHeight - 300,
      MENU_POS2, MENU_POS2 + MENU_ITEM_WIDTH, "X-Wing"));

   // Primary weapon options.
   def = new PrimaryMenuItem(Weapon::PLASMA, windowHeight - 150, windowHeight - 200,
      MENU_POS3, MENU_POS3 + MENU_ITEM_WIDTH, "Plasma");
   def->selected = true;
   primary_weapon_type_items.push_back(def);
   primary_weapon_type_items.push_back(new PrimaryMenuItem(Weapon::ENERGY, windowHeight - 200, windowHeight - 250,
      MENU_POS3, MENU_POS3 + MENU_ITEM_WIDTH, "Energy"));
   primary_weapon_type_items.push_back(new PrimaryMenuItem(Weapon::BLUE, windowHeight - 250, windowHeight - 300,
      MENU_POS3, MENU_POS3 + MENU_ITEM_WIDTH, "Blue"));
   primary_weapon_type_items.push_back(new PrimaryMenuItem(Weapon::LIGHTNING, windowHeight - 300, windowHeight - 350,
      MENU_POS3, MENU_POS3 + MENU_ITEM_WIDTH, "Lightning"));
   primary_weapon_type_items.push_back(new PrimaryMenuItem(Weapon::COOL, windowHeight - 350, windowHeight - 400,
      MENU_POS3, MENU_POS3 + MENU_ITEM_WIDTH, "Cool"));

   // Secondary weapon options.
   def = new SecondaryMenuItem(Weapon::PLASMA, windowHeight - 150, windowHeight - 200,
      MENU_POS4, MENU_POS4 + MENU_ITEM_WIDTH, "Plasma");
   def->selected = true;
   secondary_weapon_type_items.push_back(def);
   secondary_weapon_type_items.push_back(new SecondaryMenuItem(Weapon::ENERGY, windowHeight - 200, windowHeight - 250,
      MENU_POS4, MENU_POS4 + MENU_ITEM_WIDTH, "Energy"));
   secondary_weapon_type_items.push_back(new SecondaryMenuItem(Weapon::BLUE, windowHeight - 250, windowHeight - 300,
      MENU_POS4, MENU_POS4 + MENU_ITEM_WIDTH, "Blue"));
   secondary_weapon_type_items.push_back(new SecondaryMenuItem(Weapon::LIGHTNING, windowHeight - 300, windowHeight - 350,
      MENU_POS4, MENU_POS4 + MENU_ITEM_WIDTH, "Lightning"));
   secondary_weapon_type_items.push_back(new SecondaryMenuItem(Weapon::COOL, windowHeight - 350, windowHeight - 400,
      MENU_POS4, MENU_POS4 + MENU_ITEM_WIDTH, "Cool"));

   // OK button.
   ok_item = new OkMenuItem(windowHeight - 700, windowHeight - 750,
      MENU_POS_OK, MENU_POS_OK + MENU_ITEM_WIDTH, "       OK");

}

void Menus::MouseClick(int x, int y) {

   std::vector<MenuItem*>::iterator itr = team_items.begin();
   while (itr != team_items.end()) {
      MenuItem* item = (MenuItem*)(*itr);
      if (item->MouseClicked(x, y)) {
         return;
      }
      itr++;
   }

   itr = ship_type_items.begin();
   while (itr != ship_type_items.end()) {
      MenuItem* item = (MenuItem*)(*itr);
      if (item->MouseClicked(x, y)) {
         return;
      }
      itr++;
   }

   itr = primary_weapon_type_items.begin();
   while (itr != primary_weapon_type_items.end()) {
      MenuItem* item = (MenuItem*)(*itr);
      if (item->MouseClicked(x, y)) {
         return;
      }
      itr++;
   }

   itr = secondary_weapon_type_items.begin();
   while (itr != secondary_weapon_type_items.end()) {
      MenuItem* item = (MenuItem*)(*itr);
      if (item->MouseClicked(x, y)) {
         return;
      }
      itr++;
   }

   ok_item->MouseClicked(x, y);
}

void Menus::Draw() {

   glDisable(GL_DEPTH_TEST);
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
   glOrtho(0, windowWidth, 0, windowHeight, -1, 1);
	glMatrixMode(GL_MODELVIEW);
   glPushMatrix();


   std::vector<MenuItem*>::iterator itr = team_items.begin();
   while (itr != team_items.end()) {
      MenuItem* item = (MenuItem*)(*itr);
      item->Draw();
      itr++;
   }

   itr = ship_type_items.begin();
   while (itr != ship_type_items.end()) {
      MenuItem* item = (MenuItem*)(*itr);
      item->Draw();
      itr++;
   }

   itr = primary_weapon_type_items.begin();
   while (itr != primary_weapon_type_items.end()) {
      MenuItem* item = (MenuItem*)(*itr);
      item->Draw();
      itr++;
   }

   itr = secondary_weapon_type_items.begin();
   while (itr != secondary_weapon_type_items.end()) {
      MenuItem* item = (MenuItem*)(*itr);
      item->Draw();
      itr++;
   }

   ok_item->Draw();

   glColor3f(1.0f, 1.0f, 1.0f);
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
   glPopMatrix();
	glEnable(GL_DEPTH_TEST);
}
