#include <windows.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
#include "object2d.h"
#include "Camera.h"

extern Camera *camera;

Object2d::Object2d(unsigned int tex_id, const Vector3f& start, float s)
	: Object(0, start)
{
   texture_id = tex_id;
   scale = s;
}

Object2d::~Object2d() {


}

void Object2d::update(float time) {



}

void Object2d::draw() const {

   Vector3f obj_to_cam1;
   Vector3f obj_to_cam2;
   Vector3f look_at(0.0f, 0.0f, 1.0f);
   Vector3f up_aux;

	glPushMatrix();
   //glLoadIdentity();
   glTranslatef(position.x, position.y, position.z);

   obj_to_cam1.x = camera->position.x - position.x;
	obj_to_cam1.y = 0;
	obj_to_cam1.z = camera->position.z - position.z;

   obj_to_cam1.normalize();

	crossProduct(obj_to_cam1, look_at, &up_aux);

	float angle = (look_at.x * obj_to_cam1.x) + (look_at.y * obj_to_cam1.y) + (look_at.z * obj_to_cam1.z);

   if ((angle < 0.9999f) && (angle > -0.9999f))
      glRotatef(acos(angle) * 180.0f / 3.14159f, -up_aux.x, -up_aux.y, -up_aux.z);	


	obj_to_cam2.x = camera->position.x - position.x;
	obj_to_cam2.y = camera->position.y - position.y;
	obj_to_cam2.z = camera->position.z - position.z;

   if (obj_to_cam2.length() != 0.0f)
      obj_to_cam2.normalize();

   angle = (obj_to_cam2.x * obj_to_cam1.x) + (obj_to_cam2.y * obj_to_cam1.y) + (obj_to_cam2.z * obj_to_cam1.z);

   if ((angle < 0.9999f) && (angle > -0.9999f)) {
		if (obj_to_cam2.y < 0)
			glRotatef(acos(angle) * 180.0f / 3.14159f, 1.0f, 0.0f, 0.0f);	
		else
			glRotatef(acos(angle) * 180.0f / 3.14159f, -1.0f, 0.0f, 0.0f);
   }

   //glTranslatef(position.x, position.y, position.z);
   glEnable(GL_TEXTURE_2D);
   //glDisable(GL_COLOR_MATERIAL);
   glBindTexture(GL_TEXTURE_2D, texture_id);
	glBegin(GL_QUADS);
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
   glNormal3f(obj_to_cam2.x, obj_to_cam2.y, obj_to_cam2.z);
	glTexCoord2f(0.0f, 1.0f);
	glVertex3f(-scale, -scale, 0.0f);
	glTexCoord2f(1.0f, 1.0f);
	glVertex3f(scale, -scale, 0.0f);
	glTexCoord2f(1.0f, 0.0f);
	glVertex3f(scale, scale, 0.0f);
	glTexCoord2f(0.0f, 0.0f);
	glVertex3f(-scale, scale, 0.0f);
	glEnd();
	glBindTexture(GL_TEXTURE_2D, 0);
   //glEnable(GL_COLOR_MATERIAL);
   glPopMatrix();
}